<?php
namespace Bitfoundry\Etnpay\Controller\Scan;

use Magento\Framework\App\Action\Action;

class Cancel extends Action
{
    protected $resultPageFactory;
    protected $_messageManager;
    protected $orderManagement;

    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Magento\Framework\View\Result\LayoutFactory $resultLayoutFactory,
        \Magento\Sales\Api\OrderManagementInterface $orderManagement,
        \Magento\Checkout\Model\Session $checkoutSession,
        \Magento\Framework\Message\ManagerInterface $messageManager
    )
    {
        parent::__construct($context);
        $this->_resultLayoutFactory     = $resultLayoutFactory;
        $this->orderManagement          = $orderManagement;
        $this->_checkoutSession         = $checkoutSession;
        $this->messageManager           = $messageManager;
    }

    public function execute()
    {
        $this->_order = $this->_checkoutSession->getLastRealOrder();
        $this->orderManagement->cancel($this->_order->getId());
        
        $this->messageManager->addWarningMessage('Order cancelled.');
        $this->_redirect('checkout/cart', array('_secure'=> true));  
        
        return '';
    }
}
